/*************************************************************************************
 * (c) 2003, Roberto A. Foglietta <robang@libero.it>
 *     Released under Licence GPL v2.0
 *     This program is provided "as is" without warranty of any kind.  
 *     Use it at your own risk.
 *************************************************************************************/


#ifndef __MAIN_H
#define __MAIN_H


#define INFO_TESTO_TITOLO   	"\n-= Gestione grafica di login e comandi SSH =-\n"
#define INFO_TESTO_VERSIONE 	"Versione 0.7 beta\n"
#define INFO_TESTO_AUTORE	"\n(c) 2003: Roberto Foglietta <robang@libero.it>"
#define INFO_TESTO_SITOWEB	"\nhttp://digilander.iol.it/robang\n"
#define INFO_TESTO_LICENZA	"\nQuesto software  rilasciato sotto licenza GPL\n"
#define INFO_TESTO_MAX_NUM	5

#ifndef __MAIN_C
char *infotesto[INFO_TESTO_MAX_NUM] = {	INFO_TESTO_TITOLO,
					INFO_TESTO_VERSIONE,
					INFO_TESTO_AUTORE,
					INFO_TESTO_SITOWEB,
					INFO_TESTO_LICENZA  };
#else
extern char *infotesto[INFO_TESTO_MAX_NUM];
#endif
						
/* N_WIND -deve- essere una variabile puntatore alla finestra da visualizzare */
#define MOSTRA_ON_MOUSE(N_Wind) {                                        \
  gtk_window_set_position( GTK_WINDOW(N_Wind),  GTK_WIN_POS_MOUSE);      \
  gtk_widget_show (N_Wind);                                              \
}

#define MOSTRA_AL_CENTRO(N_Wind) {                                        \
  gtk_window_set_position( GTK_WINDOW(N_Wind),  GTK_WIN_POS_CENTER);      \
  gtk_widget_show (N_Wind);                                               \
}

#define get_menuitem_status(menu) (((int *)menu)[84/sizeof(int)]&1) //deprecated


enum {
 ADDUSER_ALL,
 ADDUSER_KEY,
 ADDUSER_NO1	
};

/*
   */ 
enum {
 CM_USERNAME,
 //CM_PASSWORD, 
 CM_PASSPHRASE,	
 CM_HOSTNAME, 
 CM_COMMAND,
 CM_ASKPASS,
 CM_SESSION,
 CM_ADDUSER,
 CM_MAX_NUM
};

  /*
   */ 
#define RESET_FLAG_DI_CAMPO() { 		\
  int i; 				\
  for(i = 0; i < CM_MAX_NUM; i++) {	\
	flag_di_campo[i] = 0;		\
	stringa_di_campo[i] = NULL;	\
  }					\
}

  /*
   */ 
#ifndef __MAIN_C
extern int flag_di_campo[CM_MAX_NUM];
extern char *stringa_di_campo[CM_MAX_NUM];
extern GtkWidget *gtksshlogin, *message;
#else
int flag_di_campo[CM_MAX_NUM];
char *stringa_di_campo[CM_MAX_NUM];
GtkWidget *gtksshlogin, *message;
//char *user_host_installed_keys[MAX_KEYS];
#endif

void update_user_host_installed_keys_list(void);


#define KEYB_BACKSPACE 	0xff08
#define KEYB_HOME	0xff50
#define KEYB_END	0xff57
#define KEYB_INVIO 	0xff0d
#define KEYB_CTRL  	0xffe3
#define KEYB_I     	0x0069
#define KEYB_FDOWN 	0xff54

int check_keys(void);
int check_ssh_askpass(void);


#define MAX_KEYS 128
#define APPEND   1
#define UPDATE   2
#define COMPARE  3
#define SAVEDOWN 4
#define LOADINIT 5
#define RESETALL 6
#define HIDESHOW 7

int user_host_installed_keys_list(const char *str1, int flag);

#define user_host_installed_keys_list_update() 		user_host_installed_keys_list(NULL,   	UPDATE)
#define user_host_installed_keys_list_append(string)	user_host_installed_keys_list(string, 	APPEND)
#define user_host_installed_keys_list_compare(string)	user_host_installed_keys_list(string, 	COMPARE)
#define user_host_installed_keys_list_loadinit(string)	user_host_installed_keys_list(string, 	LOADINIT)
#define user_host_installed_keys_list_savedown()	user_host_installed_keys_list(NULL, 	SAVEDOWN)
#define user_host_installed_keys_list_resetall()	user_host_installed_keys_list(NULL, 	RESETALL)
#define user_host_installed_keys_list_show()		user_host_installed_keys_list(NULL, 	HIDESHOW)
#define user_host_installed_keys_list_hide()		user_host_installed_keys_list((const char*)!NULL, 	HIDESHOW)

#endif

